"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from codat_sync_for_payables.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
import pydantic
from pydantic import model_serializer
from typing_extensions import Annotated, NotRequired, TypedDict


class CompanyInformationTypedDict(TypedDict):
    r"""Gets the latest basic info for a company."""

    company_name: NotRequired[Nullable[str]]
    r"""Name of the linked company."""
    base_currency: NotRequired[Nullable[str]]
    r"""Currency set in the accounting software of the linked company. Used by the currency rate."""


class CompanyInformation(BaseModel):
    r"""Gets the latest basic info for a company."""

    company_name: Annotated[
        OptionalNullable[str], pydantic.Field(alias="companyName")
    ] = UNSET
    r"""Name of the linked company."""

    base_currency: Annotated[
        OptionalNullable[str], pydantic.Field(alias="baseCurrency")
    ] = UNSET
    r"""Currency set in the accounting software of the linked company. Used by the currency rate."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["companyName", "baseCurrency"]
        nullable_fields = ["companyName", "baseCurrency"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
